1051 Wooden Sticks贪心

来源:互联网 发布:linux mplayer 分辨率 编辑:程序博客网 时间:2024/05/16 17:55

提交地址http://acm.hdu.edu.cn/showproblem.php?pid=1051

这两天做了几道水题练练这些基本的东西。

题目都很简单。

我忘记在什么地方看到过有个人说过:有些人认为贪心不总能求出最优解,所以所贪心没用,高手与菜鸟的区别就体现在这里。贪心用的好的一般都是大神。

所以以后要注意贪心了。

Wooden Sticks

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 10885    Accepted Submission(s): 4487


Problem Description
There is a pile of n wooden sticks. The length and weight of each stick are known in advance. The sticks are to be processed by a woodworking machine in one by one fashion. It needs some time, called setup time, for the machine to prepare processing a stick. The setup times are associated with cleaning operations and changing tools and shapes in the machine. The setup times of the woodworking machine are given as follows:

(a) The setup time for the first wooden stick is 1 minute.
(b) Right after processing a stick of length l and weight w , the machine will need no setup time for a stick of length l' and weight w' if l<=l' and w<=w'. Otherwise, it will need 1 minute for setup.

You are to find the minimum setup time to process a given pile of n wooden sticks. For example, if you have five sticks whose pairs of length and weight are (4,9), (5,2), (2,1), (3,5), and (1,4), then the minimum setup time should be 2 minutes since there is a sequence of pairs (1,4), (3,5), (4,9), (2,1), (5,2).
 

Input
The input consists of T test cases. The number of test cases (T) is given in the first line of the input file. Each test case consists of two lines: The first line has an integer n , 1<=n<=5000, that represents the number of wooden sticks in the test case, and the second line contains n 2 positive integers l1, w1, l2, w2, ..., ln, wn, each of magnitude at most 10000 , where li and wi are the length and weight of the i th wooden stick, respectively. The 2n integers are delimited by one or more spaces.
 

Output
The output should contain the minimum setup time in minutes, one per line.
 

Sample Input
3 5 4 9 5 2 2 1 3 5 1 4 3 2 2 1 1 2 2 3 1 3 2 2 3 1
 

Sample Output
213
这个题因为我搜的题的时候作者就说了这是贪心的题目,我也没多想,就写了。反正对我来说能学到东西。

因为这个处理的中间过程的时候,还出错了。

思路用该很简单,就是先排序,按照长度,长度相同按宽度排序。

调用的c++函数,很快。

最好自己写排序函数,因为我都是调用函数,所以现在让我写快排什么的 应该很费劲甚至写不出来。

长度有序了,那就不用管了。接下来我们只处理宽度就行了。

一遍一遍的遍历。遍历一遍就是结果+1,在遍历过程中 ,把这次能够处理的全部标记上已经处理了,下次就不用管了。

最后看看遍历了几次都处理了就行了。

贴上代码。

#include <iostream>#include <string.h>#include <algorithm>using namespace std;struct Point{    int l;    int w;};bool comp(Point a,Point b ){    if(a.l!=b.l)    {        return a.l<b.l;    }    else    {        return a.w<a.w;    }}int main(){    int cases;    cin>>cases;    while(cases--)    {        int n;        cin>>n;        Point p[5001];        for(int i=0;i<n;i++)        {            cin>>p[i].l;            cin>>p[i].w;        }        sort(p,p+n,comp);        int m=0,t=0;        bool b[5001];        int ans=0;        memset(b,false,sizeof(b));        while(m<n)        {            int i;            for(i=0;i<n;i++)            {                if(!b[i])                {                    t=p[i].w;                    ans++;                    m++;                    break;                }            }            for(int j=i+1;j<n;j++ )            {                if(!b[j]&&p[j].w>=t)                {                    m++;                    b[j]=true;                    t=p[j].w;                }            }        }        cout<<ans<<endl;    }    return 0;}

代码简单易懂,我用结构体存储的木棒,用bool数组来标记是否处理过了。用m来表示当前已经处理多少元素了,如果处理元素和输入个数相同了,那么while结束。

t就是当前处理的宽度,下次只能处理比当前这次宽的。

好了!

感谢自己坚持。

1 0
原创粉丝点击